Index: .hgsubstate
===================================================================
--- .hgsubstate	(revision 2584)
+++ .hgsubstate	(revision 2606)
@@ -1,1 +1,1 @@
-5d2bc58ed7d493568d5974da0e8b9019356b62a4 inc/libs/clearbricks
+40b662e0ce7bb257e56bffeead7d6996feaf9dc9 inc/libs/clearbricks
Index: admin/blog.php
===================================================================
--- admin/blog.php	(revision 2566)
+++ admin/blog.php	(revision 2596)
@@ -21,5 +21,5 @@
 
 # Create a blog
-if (!isset($_POST['id']) && !empty($_POST['blog_id']))
+if (!isset($_POST['id']) && (isset($_POST['create'])))
 {
 	$cur = $core->con->openCursor($core->prefix.'blog');
@@ -84,9 +84,4 @@
 	'<p class="form-note">'.__('At least 2 characters using letters, numbers or symbols.').'</p> ';
 
-	if ($blog_id) {
-		echo
-		'<p class="form-note warn">'.__('Please note that changing your blog ID may require changes in your public index.php file.').'</p>';
-	}
-
 	echo
 	'<p><label class="required" for="blog_name"><abbr title="'.__('Required field').'">*</abbr> '.__('Blog name:').'</label> '.
@@ -99,5 +94,5 @@
 	form::textarea('blog_desc',60,5,html::escapeHTML($blog_desc)).'</p>'.
 
-	'<p><input type="submit" accesskey="s" value="'.__('Create').'" /></p>'.
+	'<p><input type="submit" accesskey="s" name="create" value="'.__('Create').'" /></p>'.
 	'</form>';
 
Index: inc/core/class.dc.core.php
===================================================================
--- inc/core/class.dc.core.php	(revision 2593)
+++ inc/core/class.dc.core.php	(revision 2613)
@@ -40,4 +40,5 @@
 	public $log;		///< <b>dcLog</b>			dcLog object
 	public $tpl;		///< <b>Twig_Environment</b>	Twig_Environment object
+	public $stime;		///< <b>float</b>			starting time
 	
 	private $versions = null;
@@ -60,4 +61,10 @@
 	public function __construct($driver, $host, $db, $user, $password, $prefix, $persist)
 	{
+		if (defined('DC_START_TIME')) {
+			$this->stime=DC_START_TIME;
+		} else {
+			$this->stime = microtime(true);
+		}
+
 		$this->con = dbLayer::init($driver,$host,$db,$user,$password,$persist);
 		
@@ -1019,14 +1026,17 @@
 	private function getBlogCursor($cur)
 	{
-		if ($cur->blog_id !== null
-		&& !preg_match('/^[A-Za-z0-9._-]{2,}$/',$cur->blog_id)) {
+		if (($cur->blog_id !== null
+			&& !preg_match('/^[A-Za-z0-9._-]{2,}$/',$cur->blog_id)) ||
+			(!$cur->blog_id)) {
 			throw new Exception(__('Blog ID must contain at least 2 characters using letters, numbers or symbols.')); 
 		}
 		
-		if ($cur->blog_name !== null && $cur->blog_name == '') {
+		if (($cur->blog_name !== null && $cur->blog_name == '') ||
+			(!$cur->blog_name)) {
 			throw new Exception(__('No blog name'));
 		}
 		
-		if ($cur->blog_url !== null && $cur->blog_url == '') {
+		if (($cur->blog_url !== null && $cur->blog_url == '') ||
+			(!$cur->blog_url)) {
 			throw new Exception(__('No blog URL'));
 		}
@@ -1508,5 +1518,21 @@
 		}
 	}
+
+	/**
+	 Return elapsed time since script has been started
+	 @param   $mtime <b>float</b> timestamp (microtime format) to evaluate delta from
+	                       		  current time is taken if null
+	 @return <b>float</b>        elapsed time
+	 */
+	public function getElapsedTime ($mtime=null) {
+		if ($mtime !== null) {
+			return $mtime-$this->stime;
+		} else {
+			return microtime(true)-$this->stime;
+		}
+	}
 	//@}
+
+
+
 }
-?>
Index: inc/core/class.dc.themes.php
===================================================================
--- inc/core/class.dc.themes.php	(revision 2567)
+++ inc/core/class.dc.themes.php	(revision 2607)
@@ -59,5 +59,5 @@
 		# Themes specifics properties
 		$properties = array_merge(
-			array('parent' => null, 'tplset' => 'legacy'),
+			array('parent' => null, 'tplset' => DC_DEFAULT_TPLSET),
 			$properties,
 			array('permissions' => 'admin') // force themes perms
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 2593)
+++ inc/prepend.php	(revision 2613)
@@ -10,4 +10,7 @@
 #
 # -- END LICENSE BLOCK -----------------------------------------
+
+/* Start tick  */
+define('DC_START_TIME',microtime(true));
 
 /* ------------------------------------------------------------------------------------------- */
@@ -167,4 +170,5 @@
 define('DC_DISTRIB_PLUGINS','aboutConfig,akismet,antispam,attachments,blogroll,blowupConfig,dclegacy,fairTrackbacks,importExport,maintenance,pages,pings,simpleMenu,tags,themeEditor,userPref,widgets');
 define('DC_DISTRIB_THEMES','blueSilence,blowupConfig,customCSS,default,ductile');
+define('DC_DEFAULT_TPLSET','mustek');
 
 if (!defined('DC_VENDOR_NAME')) {
Index: inc/public/default-templates/currywurst/rss2.xsl
===================================================================
--- inc/public/default-templates/currywurst/rss2.xsl	(revision 2600)
+++ inc/public/default-templates/currywurst/rss2.xsl	(revision 2600)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0"
+xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+xmlns:content="http://purl.org/rss/1.0/modules/content/"
+xmlns="http://www.w3.org/1999/xhtml">
+
+<xsl:output method="html"/>
+
+<xsl:template match="/">
+<html>
+  <head>
+    <title>{{tpl:lang Subscribe to}} <xsl:value-of select="/rss/channel/title"/></title>
+    <style type="text/css">
+    <![CDATA[
+    body {
+      font: 80% Verdana,Arial,sans-serif;
+      margin: 20px 0;
+      padding: 0 0;
+      background: #fff;
+      color: #000;
+    }
+    a { color: #039; }
+    h1, h2 { font-family: Arial,sans-serif; }
+    h1 { font-size: 160%; margin: 0; }
+    h2 { font-size: 140%; font-weight: bold; margin: 0.5em 0 0.2em 0; }
+    h2 a { text-decoration: none; }
+    p { margin: 0 0 0.5em 0; }
+    #page {
+      margin: 0 80px;
+    }
+    #top {
+      background: #036;
+      padding : 1em;
+      color: #fff;
+    }
+    #top a {
+      color: #fff;
+      text-decoration: none;
+    }
+    #what {
+      padding: 1em;
+      background: #eee;
+      border-bottom: 1px solid #000;
+      font-size: 80%;
+    }
+    #what p {
+      margin: 0 0 0.5em 0;
+    }
+    #footer {
+      border-top: 1px solid #000;
+    }
+    #items {
+      background: #fff;
+      color: inherit;
+    }
+    #items div {
+      margin: 0 0 1em 0;
+    }
+    ]]>
+    </style>
+    <script type="text/javascript"><![CDATA[
+    window.onload = function() {
+      document.getElementById('feedurl').value = window.location.href;
+
+      // Ugly but works ;)
+      var c = document.getElementsByTagName('div');
+      var t = '';
+      for (var i=0; c.length-i != 0; i++) {
+        if (c[i].className == 'item-content') {
+          if (c[i].textContent) {
+            t = c[i].textContent;
+          } else if (c[i].innerText) {
+            t = c[i].innerText;
+          } else {
+            t = '';
+          }
+
+          if (t) { c[i].innerHTML = t; }
+        }
+      }
+    };
+    ]]></script>
+  </head>
+  <body>
+    <div id="page">
+      <div id="top">
+        <h1><a href="{/rss/channel/link}"><xsl:value-of select="/rss/channel/title"/></a></h1>
+        <p><xsl:value-of select="/rss/channel/description"/></p>
+      </div>
+      <div id="what">
+      <h3>{{tpl:lang What is an RSS feed?}}</h3>
+      <p>{{tpl:lang RSS feed is a free blog summary. It provides content
+      (either posts or comments) or  summaries of content, together with links
+      to the full versions, and other metadata. The last published items may
+      then be read by your favorite RSS
+      <a href="http://en.wikipedia.org/wiki/Aggregator">aggregator</a>.}}</p>
+      <h3>{{tpl:lang Subscribe}}</h3>
+      <p>{{tpl:lang Simply copy the following URL into your aggregator:}}</p>
+      <p><input type="text" size="60" value="" id="feedurl" /></p>
+      </div>
+      <div id="items">
+        <xsl:apply-templates select="//item"/>
+      </div>
+      <div id="footer">
+        <p><xsl:value-of select="/rss/channel/copyright"/></p>
+      </div>
+    </div>
+  </body>
+</html>
+</xsl:template>
+
+<!-- Item template -->
+<xsl:template match="item">
+  <div>
+    <h2><a href="{link}"><xsl:value-of select="title"/></a></h2>
+    <div class="item-content"><xsl:value-of select="description" /></div>
+  </div>
+</xsl:template>
+
+</xsl:stylesheet>
Index: inc/public/default-templates/mustek/rss2.xsl
===================================================================
--- inc/public/default-templates/mustek/rss2.xsl	(revision 2599)
+++ inc/public/default-templates/mustek/rss2.xsl	(revision 2599)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0"
+xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+xmlns:content="http://purl.org/rss/1.0/modules/content/"
+xmlns="http://www.w3.org/1999/xhtml">
+
+<xsl:output method="html"/>
+
+<xsl:template match="/">
+<html>
+  <head>
+    <title>{{tpl:lang Subscribe to}} <xsl:value-of select="/rss/channel/title"/></title>
+    <style type="text/css">
+    <![CDATA[
+    body {
+      font: 80% Verdana,Arial,sans-serif;
+      margin: 20px 0;
+      padding: 0 0;
+      background: #fff;
+      color: #000;
+    }
+    a { color: #039; }
+    h1, h2 { font-family: Arial,sans-serif; }
+    h1 { font-size: 160%; margin: 0; }
+    h2 { font-size: 140%; font-weight: bold; margin: 0.5em 0 0.2em 0; }
+    h2 a { text-decoration: none; }
+    p { margin: 0 0 0.5em 0; }
+    #page {
+      margin: 0 80px;
+    }
+    #top {
+      background: #036;
+      padding : 1em;
+      color: #fff;
+    }
+    #top a {
+      color: #fff;
+      text-decoration: none;
+    }
+    #what {
+      padding: 1em;
+      background: #eee;
+      border-bottom: 1px solid #000;
+      font-size: 80%;
+    }
+    #what p {
+      margin: 0 0 0.5em 0;
+    }
+    #footer {
+      border-top: 1px solid #000;
+    }
+    #items {
+      background: #fff;
+      color: inherit;
+    }
+    #items div {
+      margin: 0 0 1em 0;
+    }
+    ]]>
+    </style>
+    <script type="text/javascript"><![CDATA[
+    window.onload = function() {
+      document.getElementById('feedurl').value = window.location.href;
+
+      // Ugly but works ;)
+      var c = document.getElementsByTagName('div');
+      var t = '';
+      for (var i=0; c.length-i != 0; i++) {
+        if (c[i].className == 'item-content') {
+          if (c[i].textContent) {
+            t = c[i].textContent;
+          } else if (c[i].innerText) {
+            t = c[i].innerText;
+          } else {
+            t = '';
+          }
+
+          if (t) { c[i].innerHTML = t; }
+        }
+      }
+    };
+    ]]></script>
+  </head>
+  <body>
+    <div id="page">
+      <div id="top">
+        <h1><a href="{/rss/channel/link}"><xsl:value-of select="/rss/channel/title"/></a></h1>
+        <p><xsl:value-of select="/rss/channel/description"/></p>
+      </div>
+      <div id="what">
+      <h3>{{tpl:lang What is an RSS feed?}}</h3>
+      <p>{{tpl:lang RSS feed is a free blog summary. It provides content
+      (either posts or comments) or  summaries of content, together with links
+      to the full versions, and other metadata. The last published items may
+      then be read by your favorite RSS
+      <a href="http://en.wikipedia.org/wiki/Aggregator">aggregator</a>.}}</p>
+      <h3>{{tpl:lang Subscribe}}</h3>
+      <p>{{tpl:lang Simply copy the following URL into your aggregator:}}</p>
+      <p><input type="text" size="60" value="" id="feedurl" /></p>
+      </div>
+      <div id="items">
+        <xsl:apply-templates select="//item"/>
+      </div>
+      <div id="footer">
+        <p><xsl:value-of select="/rss/channel/copyright"/></p>
+      </div>
+    </div>
+  </body>
+</html>
+</xsl:template>
+
+<!-- Item template -->
+<xsl:template match="item">
+  <div>
+    <h2><a href="{link}"><xsl:value-of select="title"/></a></h2>
+    <div class="item-content"><xsl:value-of select="description" /></div>
+  </div>
+</xsl:template>
+
+</xsl:stylesheet>
Index: plugins/pages/_public.php
===================================================================
--- plugins/pages/_public.php	(revision 2586)
+++ plugins/pages/_public.php	(revision 2607)
@@ -190,5 +190,11 @@
 					header('X-Pingback: '.$core->blog->url.$core->url->getURLFor("xmlrpc",$core->blog->id));
 				}
-				$core->tpl->setPath($core->tpl->getPath(), dirname(__FILE__).'/default-templates');
+
+				$tplset = $core->themes->moduleInfo($core->blog->settings->system->theme,'tplset');
+				if (!empty($tplset) && is_dir(dirname(__FILE__).'/default-templates/'.$tplset)) {
+					$core->tpl->setPath($core->tpl->getPath(), dirname(__FILE__).'/default-templates/'.$tplset);
+				} else {
+					$core->tpl->setPath($core->tpl->getPath(), dirname(__FILE__).'/default-templates/'.DC_DEFAULT_TPLSET);
+				}
 				self::serveDocument('page.html');
 			}
Index: plugins/simpleMenu/_public.php
===================================================================
--- plugins/simpleMenu/_public.php	(revision 2576)
+++ plugins/simpleMenu/_public.php	(revision 2605)
@@ -127,5 +127,5 @@
 			// Final rendering
 			if ($ret) {
-				$ret = '<ul '.($id ? 'id="'.$id.'"' : '').' class="simple-menu'.($class ? ' '.$class : '').'">'."\n".$ret."\n".'</ul>';
+				$ret = '<ul '.($id ? 'id="'.$id.'"' : '').' class="simple-menu'.($class ? ' '.$class : '').'" role="navigation">'."\n".$ret."\n".'</ul>';
 			}
 		}
Index: plugins/tags/_public.php
===================================================================
--- plugins/tags/_public.php	(revision 2566)
+++ plugins/tags/_public.php	(revision 2607)
@@ -82,5 +82,10 @@
 	public static function addTplPath($core)
 	{
-		$core->tpl->setPath($core->tpl->getPath(), dirname(__FILE__).'/default-templates');
+		$tplset = $core->themes->moduleInfo($core->blog->settings->system->theme,'tplset');
+		if (!empty($tplset) && is_dir(dirname(__FILE__).'/default-templates/'.$tplset)) {
+			$core->tpl->setPath($core->tpl->getPath(), dirname(__FILE__).'/default-templates/'.$tplset);
+		} else {
+			$core->tpl->setPath($core->tpl->getPath(), dirname(__FILE__).'/default-templates/'.DC_DEFAULT_TPLSET);
+		}
 	}
 
Index: plugins/themeEditor/class.themeEditor.php
===================================================================
--- plugins/themeEditor/class.themeEditor.php	(revision 2566)
+++ plugins/themeEditor/class.themeEditor.php	(revision 2607)
@@ -16,9 +16,8 @@
 	protected $core;
 
-	protected $default_theme;
 	protected $user_theme;
 	protected $parent_theme;
-
-	protected $default_tpl = array();
+	protected $tplset_theme;
+
 	public $tpl = array();
 	public $css = array();
@@ -31,8 +30,13 @@
 		$this->default_theme = path::real($this->core->blog->themes_path.'/default');
 		$this->user_theme = path::real($this->core->blog->themes_path.'/'.$this->core->blog->settings->system->theme);
+		$this->tplset_theme = DC_ROOT.'/inc/public/default-templates/'.DC_DEFAULT_TPLSET;
 		if (null !== $this->core->themes) {
 			$parent_theme = $this->core->themes->moduleInfo($this->core->blog->settings->system->theme,'parent');
 			if ($parent_theme) {
 				$this->parent_theme = path::real($this->core->blog->themes_path.'/'.$parent_theme);
+			}
+			$tplset = $this->core->themes->moduleInfo($this->core->blog->settings->system->theme,'tplset');
+			if ($tplset) {
+				$this->tplset_theme = DC_ROOT.'/inc/public/default-templates/'.$tplset;
 			}
 		}
@@ -207,13 +211,9 @@
 	protected function findTemplates()
 	{
-		# First, we look in template paths
-		$this->default_tpl = $this->getFilesInDir($this->default_theme.'/tpl');
-
 		$this->tpl = array_merge(
-			$this->default_tpl,
+			$this->getFilesInDir($this->tplset_theme),
 			$this->getFilesInDir($this->parent_theme.'/tpl'),
 			$this->getFilesInDir($this->user_theme.'/tpl')
 			);
-		$this->tpl = array_merge($this->getFilesInDir(DC_ROOT.'/inc/public/default-templates'),$this->tpl);
 
 		# Then we look in 'default-templates' plugins directory
Index: plugins/widgets/_widgets_functions.php
===================================================================
--- plugins/widgets/_widgets_functions.php	(revision 2565)
+++ plugins/widgets/_widgets_functions.php	(revision 2605)
@@ -29,5 +29,5 @@
 		($w->content_only ? '' : '<div id="search"'.($w->class ? ' class="'.html::escapeHTML($w->class).'"' : '').'>').
 		($w->title ? '<h2><label for="q">'.html::escapeHTML($w->title).'</label></h2>' : '').
-		'<form action="'.$core->blog->url.'" method="get">'.
+		'<form action="'.$core->blog->url.'" method="get" role="search">'.
 		'<fieldset>'.
 		'<p><input type="text" size="10" maxlength="255" id="q" name="q" value="'.$value.'" /> '.
@@ -50,5 +50,5 @@
 		($w->content_only ? '' : '<div id="topnav"'.($w->class ? ' class="'.html::escapeHTML($w->class).'"' : '').'>').
 		($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '').
-		'<ul>';
+		'<ul role="navigation">';
 
 		if ($core->url->type != 'default') {
